

/* ------------------------------------ */
#include <stdio.h>
#include <strings.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>

#include <sys/param.h>
#include <sys/file.h>
#include <sys/time.h>
#include <sys/signal.h>
#include <termios.h>
#include <netdb.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>

#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip_icmp.h>



/* ------------------------------------ */
/* Mobile-IP ICMP extention: Mobility Agent Advertisement Extension */
struct mip_mseicmp {
	u_char  mse_type;	/* type of mobile service extension */
	u_char  mse_len;	/* length in bytes */
	u_short mse_sequence;	/* sequence number, count of adverts */
	u_short mse_lifetime;	/* list timeout */ 
	u_short mse_flags;	/* bit-field flags */

	/* followed by 0 or more Care-Of (IP) Address(s) of type u_long */
};

/* ------------------------------------ */
#define	MAXCOA		16
#define BASECOA		"10.10.0.0"
#define MAXICMPRA	16
#define BASEICMPRA	"11.11.0.0"	/* */
/* #define BASEICMPRA	"204.203.70.97"	/* */

u_long coalist[MAXCOA+1];
struct icmp_ra_addr ralist[MAXICMPRA+1];

#define PACKETSIZEMAX	2048


/* ------------------------------------ */
#define MIPAGENTAD	16
#define MIPLIFETIME	180
#define HABIT		0x2000
#define FABIT		0x1000

#define ICMPLIFETIME	300
#define ICMPADDRSIZE	2 	/* */
/* #define ICMPADDRSIZE	3	/* */
#define ICMPCODE	16

#define BEACONPERIOD	2
#define BCAST		"255.255.255.255"
#define MCAST		"224.0.0.1"
#define ROYALWLP0	"204.203.70.114"
#define BRIDGEPORTWL0	"204.203.70.97"


/* ------------------------------------ */
void usage(int exitlevel, char *message);
void parse(int argc, char *argv[]);
void initSocket(void);
void initPacket(void);
void showpacket(char *header);
static u_short in_cksum(u_short *addr, int len);

